/**
 * proto消息事件类
 */
class SocketEvent extends egret.Event {
	/** 事件名 */
	static readonly PROTO_MSG: string = "PROTO_MSG";
	/** 重连事件 */
	static readonly RECONNECT_MSG: string = "RECONNECT_MSG";
	/**语言改变 */
	static readonly LANG_CHANGE: string = 'LANG_CHANGE';

	static readonly RUN_MSG: string = "RUN_MSG";
	/** 协议号 */
	protoId: number | string = 0;
	/** 字节数组长度 */
	length: number = 0;
	/** 消息字节数组 */
	message: egret.ByteArray;

	constructor(type: string, bubbles: boolean = false, cancelable: boolean = false) {
		super(type, bubbles, cancelable);
		// 不自动创建ByteArray实例，避免只有协议号的协议导致额外的gc
		// this.message = new egret.ByteArray();
	}
}